<template>
  <div class="SplitDateTimePicker">
    <div
      v-for="type of ['date', 'time']"
      :key="type"
      :class="{
        'SplitDateTimePicker--folded': folded[type],
        ['SplitDateTimePicker__' + type]: true,
      }"
    >
      <Button
        :icon="Icons[type]"
        class="Button--noBorder Button--outlined"
        :class="{
          ['SplitDateTimePicker__' + type + 'Button']: true,
        }"
        @click="() => (folded[type] = false)"
      />
      <DateTimePicker
        :class="{ ['SplitDateTimePicker__' + type + 'Picker']: true }"
        v-model="value"
        :locale="locale"
        :timeZone="timeZone"
        :isDark="isDark"
        :debounceDelay="debounceDelay"
        :mode="type"
      />
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, reactive } from 'vue'
import DateTimePicker from '@/components/controls/DateTimePicker.vue'
import { Button } from '@/components'
import { isControl, ControlEmits } from '@/components/controls/mixins'

export default defineComponent({
  name: 'SplitDateTimePicker',
  components: {
    DateTimePicker,
    Button,
  },
  emits: [...ControlEmits, 'close', 'remove'],
  props: {
    locale: String,
    timeZone: String,
    modelValue: Date,
    foldDate: Boolean,
    foldTime: Boolean,
    isDark: Boolean,
    /**
     * Used for subsequent DateTimePicker
     */
    debounceDelay: Number,
  },

  setup(props, context) {
    return {
      folded: reactive({
        date: props.foldDate,
        time: props.foldTime,
      }),
      // Force internal debounce to 0 as one already happens within DateTimePicker subcomponent
      ...isControl<Date>({ props: { ...props, debounceDelay: 0 }, context }),
    }
  },
})
</script>

<style lang="scss" scoped>
@use '../../style/variables' as v;

.SplitDateTimePicker {
  $root: &;

  display: inline-flex;
  align-items: center;
  white-space: pre;

  &__date,
  &__time {
    display: inline-flex;
    flex-wrap: nowrap;
    align-items: center;
    justify-content: center;
  }

  &__dateButton,
  &__timeButton {
    display: none;
  }

  &--folded {
    #{$root}__dateButton,
    #{$root}__timeButton {
      display: inline-flex;
    }

    #{$root}__datePicker,
    #{$root}__timePicker {
      display: none;
    }
  }

  &--inverted {
    #{$root}__date,
    #{$root}__dateButton {
      order: 3;
    }
  }
}
</style>
